/**
* Copyright (c) 2020 The Nuinalp Authors. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/

@import '../../style/utils/animations';

//
// Main container
//

:host {
  display: inline-block;
  position: relative;
}

.nv-tooltip {
  @extend .transition-exit;
  background-color: var(--nv-contrast-color);
  border-radius: 0;
  color: var(--nv-type-primary-light);
  display: inline-block;
  padding: $space-sm $space-default;
  position: absolute;
  transition-property: opacity;
  user-select: none;
  z-index: 20;

  * {
    user-select: none;
  }

  &.nv-tooltip-hidden {
    opacity: 0;
    visibility: hidden;
  }

  &.nv-tooltip-display {
    @extend .transition-entrance;
    opacity: 1;
    visibility: visible;
  }

  .nv-tooltip-container {
    height: 100%;
    left: 0;
    position: absolute;
    top: 0;
    width: 100%;
  }

  &::after {
    border-color: transparent;
    border-style: solid;
    border-width: 5px;
    content: '';
    position: absolute;
  }

  &.nv-tooltip-top {
    left: 50%;
    min-width: 100%;
    top: calc(-100% - 8px);
    transform: translateX(-50%);

    &::after {
      border-top-color: var(--nv-contrast-color);
      left: 50%;
      margin-left: -5px;
      top: 100%;
    }
  }

  &.nv-tooltip-bottom {
    bottom: calc(-100% - 8px);
    min-width: 100%;
    right: 50%;
    transform: translateX(50%);

    &::after {
      border-bottom-color: var(--nv-contrast-color);
      bottom: 100%;
      left: 50%;
      margin-left: -5px;
    }
  }

  &.nv-tooltip-left {
    top: 50%;
    transform: translateY(-50%) translateX(calc(-100% - 16px));

    &::after {
      border-left-color: var(--nv-contrast-color);
      left: 100%;
      margin-left: 0;
      margin-top: -5px;
      top: 50%;
    }
  }

  &.nv-tooltip-right {
    top: 50%;
    transform: translateY(-50%) translateX(calc(100% + 16px));

    &::after {
      border-right-color: var(--nv-contrast-color);
      margin-right: 0;
      margin-top: -5px;
      right: 100%;
      top: 50%;
    }
  }
}

.nv-app[data-theme='dark'] .nv-tooltip {
  color: var(--nv-type-primary-dark);
}
